<?php

function smarty_function_link($params, &$smarty){
    static $files = null;
    $PATH = (isset($params['path'])) ? $params['path'] : $smarty -> get_template_vars('SZABLON_URL');

    if ( !is_array($files) ) {
        $files = array(
            'css' => array(),
            'js' => array(),
        );
    }

/**************************************************************************************************/

    $response = '';

    if ( isset($params['css']) ) {
        if ( empty($params['pack']) ) {
            $css  = __link_explode($params['css'], 'css');
            $path = $PATH.'/style/';

            foreach( $css as $plik ) {
                $response .= __link_file($files, __link_plik_url( $plik, $path ), 'css');
            }
        } else {
            $response .= __link_file($files, $params['css'], 'css');
        }
    }

    if ( isset($params['js']) ){
        if ( empty($params['pack']) ) {
            $js = __link_explode($params['js'], 'js');
            $path = $PATH . '/script/';

            foreach( $js as $plik ) {
                $response .= __link_file($files, __link_plik_url( $plik, $path ), 'js');
            }
        } else {
            $response .= __link_file($files, $params['js'], 'js');
        }
    }

/**************************************************************************************************/

    echo $response;
}

function __link_strip_ext( $plik, $type = 'js' ) {

    if ( $len = strlen($type) ) {
        $len++; //zwiekszam o jeden bo jeszcze kropka '.'
        while ( strcasecmp( substr( $plik, -1 * $len ), '.' . $type ) == 0 ) {
            $plik = substr( $plik, 0, -1 * $len );
        }
    }

    return $plik;
}


function __link_explode( $str, $type = 'js' ){
    $pliki = explode(',', $str );

    for( $len = strlen($type) + 1, $i = 0, $lp = count($pliki); $i < $lp; $i++ ){
        $pliki[$i] = __link_strip_ext(trim($pliki[$i]), $type);
    }

    return $pliki;
}

function __link_plik_url( $plik, &$path ) {

    if ( substr($plik, 0, 1) == '/' ) {
        $path = dirname($plik) . '/' ;
        $plik = basename($plik);
    }

    return $path . $plik;
}

function __link_file( &$files, $src, $ext = null ) {
    if ( !$ext ) {
        $parts = explode('.', $src);
        $ext = $parts[count($parts) -1];
    }

    if ( substr($str, -1 * (strlen($ext) + 1)) !== '.' . $ext ) {
        $src .= '.' . $ext;
    }

    if ( isset($files[$ext]) && isset($files[$ext][$src]) ) {
        return '';
    }

    //zapisuje
    $files[$ext][$src] = true;

    if ( $ext == 'css' ) {
        return '<link rel="stylesheet" href="' . $src . '" type="text/css">'. "\n";
    } else if ( $ext == 'js' ) {
        return '<script type="text/javascript" src="'. $src. '"></script>' . "\n";
    }
}