/**
 * Binarne wyszukiwanie w posortowanej tablicy, mam nadzieje e przyspieszy dodawanie wybranych elementw
 * do tablicy
 */
Array.prototype.binarySearch = function(find, comparator) {
    var low = 0, high = this.length - 1, i, comparison;

    if ( typeof(comparator) != 'function' ) {
        comparator = function (a, b) {
            return a - b;
        }
    }

    while ( low <= high ) {
        i = Math.floor((low + high) / 2);
        comparison = comparator(this[i], find);
        if ( comparison < 0 ) {
            low = i + 1;
            continue;
        };

        if ( comparison > 0) {
            high = i - 1;
            continue;
        };

        return i;
    }

    return -1;
};

/**
 * Binarne wstawienie do posortowanej tablicy,
 */
Array.prototype.qpush = function( find, comparator ) {
    var low = 0, high = this.length - 1, i, comparison;

    if ( typeof(comparator) != 'function' ) {
        comparator = function (a, b) {
            return a - b;
        }
    }

    while ( low <= high ) {
        i = Math.floor((low + high) / 2);

        comparison = comparator(this[i], find);
        if ( comparison < 0 ) {
            low = i + 1;
            continue;
        };

        if ( comparison > 0) {
            high = i - 1;
            continue;
        };

        //nie wstawiamy
        return i;
    }


    if ( high < 0 ) {
        i = 0
    } else if ( low >= this.length ){
        i = this.length;
    } else {
        i = low;
    }

    this.splice( i, 0, find );
    return i;
};

function EcSelection( content, options ){
    var $ajaxLoader = null, self = this;

    this.$content = $(_target(content));

    if ( options.target ) {
        this.$target = $(_target(options.target));
    } else {
        this.$target = this.$content;
    }

    this.name = this.$content.attr('rel');
    if ( !this.name ) {
        this.name = '';
    }
    var rel = this.name.split('.');
    this.foreignKey = (rel.length > 0 ) ? rel[rel.length-1] : '';

    //tablica zawierajaca zaznaczone elementy
    if( options.selected ){
        this.selected = options.selected;
    }else{
        this.selected = [];
    }

    if( options.records ){
        this.records = options.records;

        if( !options.metadata ){
            options.metadata = true;
        }
    }else{
        this.records = {};
    }

    if ( options.metadata ) {
        self.metadata = {
           type: 'class'
        };

        if ( typeof(options.metadata) == 'object' ) {
            self.metadata = $.extend(self.metadata, options.metadata);
        }
    }

    if( options.setup && typeof(options.setup) == 'function' ){
        this.setupCallback = options.setup;
    }else{
        this.setupCallback = null;
    }

 /*************************************************************************************************/
    this.ajaxOptions = {
        'dataType' :  'html',

        'success' : function(data){
            _hideAjaxLoading();

            self.$target.html(data).css({
                'opacity' : 1
            });

            self.setup(self.$target);
        },

        'error' : function(){
            //hideLoading();
            //print_message( 'Przez serwer zostaa zwrcona nieprawidowa odpowied' );
            console.log( 'Przez serwer zostaa zwrcona nieprawidowa odpowied' );
        },

        'beforeSend' :  function() {
            _showAjaxLoading(self.$target);

            self.$target.css({
                'opacity' : 0.6
            });
        }
    }

/**************************************************************************************************/
    this.onselect = function( event ){
        var checked = false, data = null;
        if ( arguments.length > 1  ) {
            //jest odpalne przez trigger i wykona sie wczesniej ni
            checked = !this.checked;
        } else{
            checked = this.checked;
        }

        var id = parseInt(this.value), record_index = -1;
        if ( id > 0 ) {
            if ( checked ) {
                self.selected.qpush(id);
                if ( self.metadata ) {
                    data = $(this).parents('tr').metadata(self.metadata);
                    data.id = id;
                    self.records[id] = data;
                }

                //console.log('Dodaje: ' + id + ' length: ' + self.selected.length )
            } else {
                record_index = self.selected.binarySearch(id);

                if ( record_index != -1 ) {
                    self.selected.splice(record_index, 1);

                    if ( self.records && typeof(self.records[id]) == 'object' ){
                        delete self.records[id];
                    }
                }
                //console.log('Usuwam: ' + id + ', index: ' + record_index + ', length: ' + self.selected.length );
            }
        }
    }

    /**
     * funkcja ktra usuwa z
     * 
     * @param {type} id
     * @returns {undefined}
     */
    this.remove = function( id ){
        if ( id > 0 ) {
            var record_index = this.selected.binarySearch(id);

            if ( record_index != -1 ) {
                this.selected.splice(record_index, 1);

                if ( this.records && typeof(this.records[id]) == 'object' ){
                    delete this.records[id];
                }

                this.$target.find('input[name^=selected]').each(function(){
                    if( this.value ==  id ) {
                        this.checked = false;
                    }
                });
            }
        }
    }

    this.setup = function ( $target ){
        if( !$target ){
            $target = this.$target;
        }

        if ( this.setupCallback ) {
            this.setupCallback($target);
        }

        var $strona = $target.find("#strona_input").unbind('blur').unbind('change').focus(function(){
            $(this).data('value', this.value);
        }).blur(function(){
            if ( this.value && this.value != $(this).data('value') ){
                $(this.form).submit();
            }
        });

        if($strona.length > 0 ) {
            $strona[0].onblur = function(){};
            $strona[0].onchange = function(){};
        }

        $target.find("form").submit(function(){
            $(this).ajaxSubmit(self.ajaxOptions);
            return false;
        });

        $target.find(".pagination a, th a").click(function( e ){
            e.preventDefault();
            $.ajax( $.extend( {'url' : $(this).attr('href') }, self.ajaxOptions) );
            return false;
        });

        $target.find("input[name^=selected]").click(self.onselect).each(function(){
            if ( self.selected.binarySearch(this.value) != -1 ) {
                this.checked = true;
            }
        });

        $target.find("input.changeSelection").click(function(){
//            $('input[name^=selected]', this.form).each(function(){
//                $(this).trigger('click', 'triggered');
//            });

            var checked = this.checked;
            $('input[name^=selected]', this.form).each(function(){
                this.checked = checked;
                $(this).triggerHandler('click');
            });
        });
    }

    this.appendTo = function(form, options ){
        if ( !form ) {
            return;
        }

        options = $.extend( { 'prefix' : '', 'assoc' : false, 'field' : '', 'selected' : null, 'fields' : null }, options);

        var id, value, k, o, v, f = options.field;
        var input = options.prefix + 'selected';

        $(form).find('input[name^='+input+']').remove();

        var selected = this.selected;
        if ( options.selected && typeof(options.selected.length) != 'undefined' ) {
            selected = [];
            for ( var i = 0; i < options.selected.length; i++ ) {
                if ( this.selected.binarySearch(options.selected[i]) != -1 ) {
                    selected.push( options.selected[i] );
                }
            }
        }

        for ( var i = 0; i < selected.length; i++ ) {
            id = selected[i];

            if ( f && this.records && this.records[id] && typeof(this.records[id][f]) != 'undefined' ) {
                value = this.records[id][f];
            } else {
                value = id;
            }

            if ( value ){
                if ( options.fields  ) {
                    k =  options.assoc ? id : i ;
                    if ( options.fields.length && options.fields[0] ) {
                        for ( var j = 0; j < options.fields.length; j++ ) {
                            if ( options.fields[j] && typeof(options.fields[j]) == 'string' ) {
                                v = ''; o = options.fields[j];
                                if ( this.records && this.records[id] && typeof(this.records[id][o]) != 'undefined' ) {
                                    v = this.records[id][o];
                                }

                                $(form).append('<input type="hidden" name="'+input+'[' + k + '][' + o + ']" value="' + v + '" />');
                            }
                        }
                    } else {
                        for ( o in options.fields ) {
                            if ( typeof(options.fields[o]) == 'string' ) {
                                v = '';
                                if ( this.records && this.records[id] && typeof(this.records[id][o]) != 'undefined' ) {
                                    v = this.records[id][o];
                                }

                                $(form).append('<input type="hidden" name="'+input+'[' + k + '][' + options.fields[o] + ']" value="' + v + '" />');
                            }
                        }
                    }
                } else {
                    $(form).append('<input type="hidden" name="'+input+'[' + ( options.assoc ? id : i ) + ']" value="' + value + '" />');
                }
            }
        }
    }

    this.setup(this.$content);

    function _randomstr( length ){
        if( !length > 0 ){
            length = 10;
        }

        var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz";
        for ( var i = 0; i < length; i++ ) {
            var rnum = Math.floor(Math.random() * chars.length);
            randomstring += chars.substring(rnum, rnum+1);
        }

        return randomstring;
    }

    function _target(target){
        if ( typeof(target) == 'string' ) {
            if( target.substr(0, 1) != '#' ) {
                target = '#' + target;
            }
        }

        return target;
    }

    function _showAjaxLoading ( obj ) {
        if ( !$ajaxLoader || !$ajaxLoader.length ) {
            $ajaxLoader = $('#ajaxLoader');

            if ( $ajaxLoader.length == 0 ) {
                $('body').append(
                    $ajaxLoader = $('<div style="position: absolute" class="loader"></div>').hide()
                );
            }
        }

        var opts = {
            'at' : 'center',
            'my' : 'center'
        };
        if ( obj ) {
            opts.of = obj;
        }
        $ajaxLoader.show();
        $ajaxLoader.position(opts);
    }

    function _hideAjaxLoading ( ) {
        if ( $ajaxLoader && $ajaxLoader.length ) {
            $ajaxLoader.hide();
        }
    }

    function pr ( obj, name, indent ) {
        var output = '', space = '', i = 0, o;

        if ( !indent ) {
            indent = 0;
        }

        if ( !name ) {
            name = '';
        }

        for ( i = 0; i < indent; i++ ) {
            space += "\t";
        }

        if ( typeof(obj) == 'object' ) {
            for ( o in obj ){
                //output += pr(obj[o], o + ':', indent + 1);
                output += space + o + ':' + obj[o]  + "\n";
            }
        } else {
            output += space + name + obj;
        }

        return output;
    }
}