/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

//staa zawierajca list krajw wraz kodami
var COUNTRIES = [];

var message_pnotify = null;
function print_message(body, type){
    if ( typeof arguments[0] == 'object' ) {
        if ( body.message ) {
            if ( body.message.type ) {
                type = body.message.type;
            }

            var message = body.message.body;
            if ( body.error ) {
                type = 'error';

                if ( body.object ) {
                    message = 'Wystpiy bdy: <ol>';
                    for( var err in body.object ){
                        message += '<li>' + body.object[ err ] + '</li>';
                    }
                    message += '</ol>';
                }
            }
            body = message;
        } else {
            type = body.type;
            body = body.body;
        }
    }

    var delay = Math.max( 5000, (body.length / 5) * 800);  //czas wyswietlania w zaleznosci od dlugosic tekstu
    var title = (type == 'error')? 'Bd' : 'Informacja';
    if( !type ) type = 'notice';

    if ( message_pnotify && message_pnotify.pnotify_remove){
        message_pnotify.opts.pnotify_animation = 'none';
        message_pnotify.pnotify_remove();
    }

    message_pnotify = jQuery.pnotify({
        pnotify_title: title,
        pnotify_type: type,
        pnotify_text: body,
        pnotify_hide: true,
        pnotify_delay: delay,
        'styling' : 'jqueryui',
        pnotify_animation: 'fade'
    });
}

var $confirmDialog = null;
function confirmDialog( message, options ){
    var cancelCallback, confirmCallback = null;

    if ( !$confirmDialog || ($confirmDialog.length == 0) ) {
        $confirmDialog = $('#confirmDialog');

        if ( $confirmDialog.length == 0 ) {
            $('body').append(
                $confirmDialog = $('<div id="confirmDialog"></div>').hide()
            );
        }

        $confirmDialog.dialog( {
            'autoOpen' : false,
            'model' : false,
            'maxWidth': 800,
            'maxHeight': 600,
            'position' : 'center',
            'title' : 'Komunikat',
            'width' : 400,
            'height' : 'auto',
            'close' : function (){
                hideTlo();
            },
            'open' : function (){
                showTlo();
            }
        });
    }

    $confirmDialog.html(message);

    if ( !options ) options = {};

    if ( typeof(options) == 'function' ){
        confirmCallback = options;
        options = {};
    }

    if ( options.confirm  ) {
        if( typeof(options.confirm) == 'function'){
            confirmCallback = options.confirm;
        }

        delete options['confirm'];
    }

    if ( options.cancel  ) {
        if ( typeof(options.cancel) == 'function' ){
            cancelCallback = options.cancel;
        }

        delete options['cancel'];
    }

    $confirmDialog.dialog( 'option', 'buttons',  [
        {
            text: "Anuluj",
            icons : {
                'primary' : 'ui-icon-cancel'
            },
            click: function() {
                $(this).dialog("close");

                if( cancelCallback && typeof(cancelCallback) == 'function' ){
                    cancelCallback();
                }
            }
        },
        {
            text: "Ok",
            icons : {
                'primary' : 'ui-icon-check'
            },
            click: function() {
                $(this).dialog("close");

                if( confirmCallback && typeof(confirmCallback) == 'function' ){
                    confirmCallback();
                }
            }
        }
    ]);

    var o, optionsList = [ 'title', 'modal', 'buttons' ];
    for( var i = 0; i < optionsList.length; i++ ) {
        o = optionsList[i];
        if ( options[o] ) {
            $confirmDialog.dialog( 'option', o, options[o] );
        }
    }

    $confirmDialog.dialog( "open" );
}

jQuery.fn.textPlaceholder = function () {
    return this.each(function(){
        var that = this;

        var placeholder = that.getAttribute('title');
        var input = jQuery(that);

        if (that.value === '' || that.value == placeholder) {
            input.addClass('text-placeholder');
            that.value = placeholder;
        }

        input.focus(function(){
            if (input.hasClass('text-placeholder')) {
                this.value = '';
                input.removeClass('text-placeholder')
            }
        });

        input.blur(function(){
            if (this.value === '') {
                input.addClass('text-placeholder');
                this.value = placeholder;
            } else {
                input.removeClass('text-placeholder');
            }
        });
    });
};



function intval(mixed_var, base) {
    //  discuss at: http://phpjs.org/functions/intval/
    // original by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // improved by: stensi
    // bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // bugfixed by: Brett Zamir (http://brett-zamir.me)
    // bugfixed by: Rafa Kukawski (http://kukawski.pl)
    //    input by: Matteo
    //   example 1: intval('Kevin van Zonneveld');
    //   returns 1: 0
    //   example 2: intval(4.2);
    //   returns 2: 4
    //   example 3: intval(42, 8);
    //   returns 3: 42
    //   example 4: intval('09');
    //   returns 4: 9
    //   example 5: intval('1e', 16);
    //   returns 5: 30

    var tmp;

    var type = typeof mixed_var;

    if (type === 'boolean') {
        return +mixed_var;
    } else if (type === 'string') {
        tmp = parseInt(mixed_var, base || 10);
        return (isNaN(tmp) || !isFinite(tmp)) ? 0 : tmp;
    } else if (type === 'number' && isFinite(mixed_var)) {
        return mixed_var | 0;
    } else {
        return 0;
    }
}


function is_numeric(mixed_var) {
    //  discuss at: http://phpjs.org/functions/is_numeric/
    // original by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // improved by: David
    // improved by: taith
    // bugfixed by: Tim de Koning
    // bugfixed by: WebDevHobo (http://webdevhobo.blogspot.com/)
    // bugfixed by: Brett Zamir (http://brett-zamir.me)
    // bugfixed by: Denis Chenu (http://shnoulle.net)
    //   example 1: is_numeric(186.31);
    //   returns 1: true
    //   example 2: is_numeric('Kevin van Zonneveld');
    //   returns 2: false
    //   example 3: is_numeric(' +186.31e2');
    //   returns 3: true
    //   example 4: is_numeric('');
    //   returns 4: false
    //   example 5: is_numeric([]);
    //   returns 5: false
    //   example 6: is_numeric('1 ');
    //   returns 6: false

    var whitespace = " \n\r\t\f\x0b\xa0\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u200b\u2028\u2029\u3000";

    return (typeof mixed_var === 'number' || (typeof mixed_var === 'string' && whitespace.indexOf(mixed_var.slice(-1)) === -1)) && mixed_var !== '' && !isNaN(mixed_var);
}

/**
 * Konwertuje ciag znagw JSON na obiekt o ile nie zawiera bdw bo wwczas zwraca null
 *
 * @param String|Object str
 * @returns obj
 */
function str2obj( str ) {
    var obj = null;

    if ( str && typeof(str) === 'string' && str.substr(0,1) === '{' && str.substr(str.length-1) === '}'  ) {
        try{
            obj = eval('(' + str +')')
        }catch( e ) {
            //console.log(e);
            obj = null;
        }
    } else if ( str && typeof(str) == 'object' ) {
        obj = str;
    }

    return obj;
}



if ( jQuery && jQuery.fn && typeof(jQuery.fn) == 'object' ) {
    (function(){
        if ( typeof(window.COUNTRIES) == 'undefined' ) {
            window.COUNTRIES = [];
        }
        var _countries = [];

        function prepare_countries(){
            var i = 0, f, country;

            _countries = [];
            for ( i = 0 ; i < COUNTRIES.length; i++ ) {
                country = COUNTRIES[i];

                for ( f in country ) {
                    if( typeof(country[f]) == 'string' ) {
                        //zamieniam na mae literki aby uatwic wyszukiwanie
                        country['_' + f] = country[f].toLowerCase();
                    }
                }

                //ustawiam wartosc i etykiete
                country.value = country.label = country.name_pl;
                //dodaje do listy krajw
                _countries.push(country);
            }
        }

        var COUNTRY_FLAG_URL = (( typeof(window.IMAGES_URL) == 'string' ) ? window.IMAGES_URL : '/images') + '/flags_iso/16/';

        jQuery.fn.countryCombobox = function(options){
            this.each(function(){

                if ( !this.countryCombobox ) {
                    this.countryCombobox = true;

                    if ( !options ) options = {};
                    options = jQuery.extend({
                        field_value: null,
                        renderItem: false,
                        afterSelect: false
                    }, options);

                    var $this = jQuery(this);
                    $this.css({
                        'vertical-align': 'middle'
                    }).wrap('<span>');

                    $this.autocomplete({
                        //disabled: true,
                        minLength: 1,
                        select: function( event, ui ) {
                            if ( event && event.preventDefault && typeof(event.preventDefault) == 'function' ) {
                                event.preventDefault();
                            }

                            if ( ui && ui.item && typeof(ui.item) == 'object' ) {
                                if ( options.field_value && typeof(ui.item[options.field_value]) != 'undefined' ) {
                                    $this.val(ui.item[options.field_value]);
                                } else {
                                    $this.val(ui.item.value);
                                }

                                if ( options.afterSelect && typeof(options.afterSelect) ){
                                    options.afterSelect.call(this, ui);
                                }
                            }

                            return false;
                        },
                        source: function( request, response ){
                            var items = [];

                            if ( COUNTRIES ) {
                                if( !_countries.length || COUNTRIES.length != _countries.length ){
                                    prepare_countries();
                                }
                            }

                            var term = ( request.term && typeof(request.term) == 'string' ) ? request.term.toLowerCase() : '';
                            var regexp = new RegExp("\\b" + term.replace(/[-\/\\^$*+?.()|[\]{}]/g, '\\$&'));

                            //console.log('countryCombobox source');
                            for ( var i = 0; i < _countries.length; i++  ){
                                if ( !term || _countries[i]._name_pl.match( regexp ) || _countries[i]._alpha2.match( regexp ) || _countries[i]._alpha3.match( regexp ) /*|| _countries[i].label.indexOf(request.term) == 0 */ ) {
                                    items.push(_countries[i]);
                                }
                            }

//                            if( term ) {
//                                console.log(regexp)
//                                console.log('szukam tekstu: ' + term);
//                                console.log(items);
//                            }

                            //musi byc wywoane aby wyswietliy sie podpowiedzi
                            response( items);
                        }
                    })

                    //console.log($this.autocomplete( "instance" ));

                    $this.data('autocomplete')._renderItem = function( ul, item ) {
                        if ( options.renderItem && typeof(options.renderItem) == 'function' ) {
                            return options.renderItem.call( this, ul, item);
                        }

                        return $( "<li>" )
                          .append( "<a title="+item.alpha2+"><img src=\""+COUNTRY_FLAG_URL+item._alpha2+".png\" alt=\""+item.alpha2+"\" />" + item.label + ' ' + item.alpha2 + "</a>" )
                          .appendTo( ul );
                    };

                    //console.log($this.attr('name') + '.height(): ' + $this.height());
                    var $btn = jQuery('<a>');
                    $btn.button({
                        icons: {
                            primary: 'ui-icon-triangle-1-s'
                        },
                        text: false
                    }).click(function(e){
                        e.preventDefault();

                        var $a = $(this);

                        //jesli autocomplete jest waczony to zamykam
                        if ( !$a.data("autocomplete_is_open") ) {
                            $this.autocomplete("option","minLength", 0);
                            $this.autocomplete("search","");
                            $this.autocomplete("option","minLength", 1);

                            //zaznaczam ze autocomplete zosta otworzony
                            $a.data("autocomplete_is_open", true);

                            jQuery(document).bind('click.countryAutocompleteClose', function(e){
                                //jesli klikniecie gdzie na dokumencie nastapilo to zamykam
                                $this.autocomplete("close");
                                //
                                $a.data("autocomplete_is_open", false);
                                //odwiazuje zdarzenie
                                jQuery(document).unbind('click.countryAutocompleteClose');
                            });
                        } else {
                            //zamykam autocomplete'a
                            $this.autocomplete("close");

                            //jeszzce odwizuje
                            if ( $a.data('autocomplete_is_open') ) {
                                jQuery(document).unbind('click.countryAutocompleteClose');
                                $a.data("autocomplete_is_open", false);
                            }
                        }

                        return false;
                    }).removeClass('ui-corner-all').addClass('ui-corner-right').css({
                        'height': 17,
                        'display': 'inline-block',
                        'vertical-align': 'middle',
                        'border-left' : 'none'
                    });

                    $this.parent().addClass('country-combobox').css({
                        'display': 'block'
                    }).append($btn);
                }
            });
        }

    })();
    var countryComboboxIndex = 0;


}

if( jQuery.validator ){
    jQuery.validator.addMethod("config_name", function(value, element) {
        return this.optional(element) || /^[a-zA-Z][a-zA-Z0-9\-_]+$/i.test(value);
    }, "Dopuszczalne s wycznie litery, cyfry i znak podkrelenia lub mylnik");

    jQuery.validator.addClassRules('config-name', {
        'config_name' : true
    });

/**
 * Checks that a value is a valid decimal. Both the sign and exponent are optional.
 *
 * Valid Places:
 *
 * - null => Any number of decimal places, including none. The '.' is not required.
 * - true => Any number of decimal places greater than 0, or a float|double. The '.' is required.
 * - 1..N => Exactly that many number of decimal places. The '.' is required.
 *
 * @param float value The value the test for decimal
 * @param integer $places
 * @param string $regex If a custom regular expression is used, this is the only validation that will occur.
 * @return boolean Success
 */
	function decimalCheck(value, element, places  ) {
        var regex;
        var lnum = '[0-9]+';
        var dnum = '[0-9\\s]*[\\.,]' + lnum;
        var sign = '[+-]?';
        var exp = "([eE]" + sign + lnum + ")?";

        if ( is_numeric(places)) {


            places = '[0-9]{' + places + '}';
            dnum = "([0-9\\s]*[\\.,]"+places+"|[0-9\\s]+[\\.,]"+places+")";
            regex = new RegExp("^" + sign + dnum + exp + "$");
        } else {
            regex = new RegExp("^" + sign + "([0-9\\s]+|"+dnum+")" + exp + "$");
        }

        //console.log('places: ' + places + ', regex : ' + regex );
		return this.optional(element) || regex.test(value);
	}

    jQuery.validator.addMethod("decimal", decimalCheck, "Podaj prawidow warto liczbow");

    jQuery.validator.addClassRules('decimal', {
        'decimal' : true
    });

    /**
 * Checks if a value is a natural number.
 *
 * @param string $check Value to check
 * @param boolean $allowZero Set true to allow zero, defaults to false
 * @return boolean Success
 * @see http://en.wikipedia.org/wiki/Natural_number
 */
	function intvalCheck( value, element ) {
        if( typeof(value) != 'string' ) {
            value = '';
        }
        value = value.replace(/^\s+/, '').replace(/\s+$/, '');
		var regex = /^(?:0|[1-9][0-9\s]*)$/;

        return this.optional(element) || regex.test(value);
	}

    jQuery.validator.addMethod("intval", intvalCheck, "Podaj prawidow liczb cakowit.");

    jQuery.validator.addClassRules('intval', {
        'intval' : true
    });

    /**
     * funkcja do przekonwertowania liczby podanej w inpucie na wartosc liczbow kasowane s spacje, a przecinek
     * jest zmieniany na kropk
     *
     * @param {type} val
     * @returns {Number}
     */
    function floatval( val ){
        if ( typeof(val) == 'string' ) {
            val = val.replace(',', '.').replace(' ', '');
        }

        val = parseFloat(val);
        if ( isNaN(val) ) {
            val = 0;
        }

        return val;
    }

    jQuery.validator.addMethod("min", function( value, element, param ) {
        if ( !value || this.optional(element) ) {
            return true;
        }

        return floatval(value) >= param;
    }, jQuery.validator.format("Wprowad warto wiksz lub rwn {0}."));

    jQuery.validator.addClassRules('min0', {
        'min' : 0
    });

    jQuery.validator.addMethod("greater_than", function( value, element, param ) {
        return this.optional(element) || floatval(value) > param;
    }, jQuery.validator.format("Wpisana warto musi by wiksza ni {0}"));

    jQuery.validator.addClassRules('gt0', {
        'greater_than' : 0
    });

    jQuery.validator.addMethod("less_than", function( value, element, param ) {
        return this.optional(element) || floatval(value) < param;
    }, "Wpisana warto musi by mniejsza ni {0}.");

    jQuery.validator.addClassRules('lt0', {
        'less_than' : 0
    });

    jQuery.validator.addMethod("postcode", function( value, element) {
        if( typeof(value) != 'string' ) {
            value = '';
        }
        value = value.replace(/^\s+/, '').replace(/\s+$/, '');

        return this.optional(element) || value.match(/^[0-9]{2}-[0-9]{3}$/);
    }, "Kod pocztowy musi by wpisany w formacie XX-XXX.");

    jQuery.validator.addClassRules('postcode', {
        'postcode' : true
    });

    jQuery.validator.addMethod("country_code", function( value, element, param ) {
        if( typeof(value) != 'string' ) {
            value = new String();
        }

        if( value == '' && this.optional(element) ){
            return true;
        }

        value = value.replace(/^\s+/, '').replace(/\s+$/, '');
        var regex = null, f, msg;
        if ( param && (param === '3' || param === 'alpha3' || param === 3 || param === 'alfa3'  ) ) {
            //by alpha 3
            regex = /^[A-Za-z]{3}$/;
            f = 'alpha3';
            msg = 'Kod kraju powinien by trzy-znakowy.';
        } else {
            //default by alpha 2
            regex = /^[A-Za-z]{2}$/;
            f = 'alpha2';
            msg = 'Kod kraju powinien by dwu-znakowy.';
        }

        if ( !value.match(regex) ) {
            jQuery(element).data('msg-country_code', msg);
            return false;
        }

        //jesli lista krajw jest pusta to zwracam true
        if ( typeof(window.COUNTRIES) == 'undefined' || !COUNTRIES || COUNTRIES.length == 0 ) {
            return true;
        }
        /** @var String value */
        value = value.toUpperCase();

        for ( var i = 0; i < COUNTRIES.length; i++ ) {
            if ( COUNTRIES[i][f] == value ) {
                return true;
            }
        }

        jQuery(element).data('msg-country_code', 'Nie ma kraju o kodzie: ' + value );

        return false;
    }, "Nieprawidowy kod kraju");

    jQuery.validator.addClassRules('country-code', {
        'country_code' : true
    });

    jQuery.validator.addClassRules('country-code2', {
        'country_code' : 'alpha2'
    });

    jQuery.validator.addClassRules('country-code3', {
        'country_code' : 'alpha3'
    });


    /**
    * Checks if a value is a correct bank account.
    *
    * @param string value to check
    * @return boolean Success
    */
    jQuery.validator.addMethod("accountNumber", function ( value, element ) {
        if( typeof(value) != 'string' ) {
            value = '';
        }
        value = value.replace(/^\s+/, '').replace(/\s+$/, '');
		if( value == '' && this.optional(element) ) {
            return true;
        }

        if ( !value.match(/^[0-9\s]+$/) ) {
            jQuery(element).data('msg-accountNumber', 'Numer konta moe skada si wycznie z cyfr i znakw spacji oddzielajcych od siebie bloki cyfr.');
            return false
        }

        value = value.replace(/[^0-9]/g, '');
        if ( value.length != 26 ) {
            jQuery(element).data('msg-accountNumber', 'Numer konta musi si skada z 26-ciu cyfr.');
            return false;
        }

        return true;
	}, "Nieprawidowy numer konta.");

    jQuery.validator.addClassRules('account-number', {
        'accountNumber' : true
    });
}


