

/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/


CREATE GENERATOR WWW_PROGI_CEN_ID_GEN;

CREATE TABLE WWW_PROGI_CEN (
    ID           INTEGER NOT NULL,
    TOWAR_ID     ID_D /* ID_D = INTEGER DEFAULT 0 NOT NULL */,
    GRUPA_ID     ID_D /* ID_D = INTEGER DEFAULT 0 NOT NULL */,
    PROG_OD      ILOSC_D NOT NULL /* ILOSC_D = NUMERIC(15,4) DEFAULT 0 NOT NULL CHECK  (VALUE >=0) */,
    CENA_ID      ID_D /* ID_D = INTEGER DEFAULT 0 NOT NULL */,
    CENA_NETTO   CENAN_D /* CENAN_D = NUMERIC(15,4) NOT NULL */,
    CENA_BRUTTO  CENAN_D /* CENAN_D = NUMERIC(15,4) NOT NULL */
);




/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_PROGI_CEN ADD CONSTRAINT WWW_PROGI_CEN_PK PRIMARY KEY (ID);


/******************************************************************************/
/****                             Foreign Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_PROGI_CEN ADD CONSTRAINT WWW_PROGI_CEN_CENA_ID_FK FOREIGN KEY (CENA_ID) REFERENCES GM_CENY (ID) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE WWW_PROGI_CEN ADD CONSTRAINT WWW_PROGI_CEN_GRUPA_ID_FK FOREIGN KEY (GRUPA_ID) REFERENCES GM_GRUPYT (ID) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE WWW_PROGI_CEN ADD CONSTRAINT WWW_PROGI_CEN_TOWAR_ID_FK FOREIGN KEY (TOWAR_ID) REFERENCES GM_TOWARY (ID) ON DELETE CASCADE ON UPDATE CASCADE;


/******************************************************************************/
/****                               Triggers                               ****/
/******************************************************************************/


SET TERM ^ ;


/******************************************************************************/
/****                         Triggers for tables                          ****/
/******************************************************************************/



/* Trigger: WWW_PROGI_CEN_BI */
CREATE TRIGGER WWW_PROGI_CEN_BI FOR WWW_PROGI_CEN
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_PROGI_CEN_ID_GEN,1);
END
^


SET TERM ; ^


/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/

/* Privileges of roles */
GRANT ALL ON WWW_PROGI_CEN TO WWW_ROLE;