
/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/



CREATE TABLE WWW_PLATNOSCI (
    ID           ID_D NOT NULL /* ID_D = INTEGER DEFAULT 0 NOT NULL */,
    NAZWA        STRING250_D /* STRING250_D = VARCHAR(250) */,
    ZNACZNIK_ID  ID_D /* ID_D = INTEGER DEFAULT 0 NOT NULL */,
    ESKLEP       BOOLEAN_D /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    B2B          BOOLEAN_D /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    MOBILE       BOOLEAN_D /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    INSTALACJA   WWW_INSTALACJA_D /* WWW_INSTALACJA_D = VARCHAR(30) */,
    CDATE        DATA_TIME_D NOT NULL /* DATA_TIME_D = TIMESTAMP */,
    MDATE        DATA_TIME_D NOT NULL /* DATA_TIME_D = TIMESTAMP */
);




/******************************************************************************/
/****                             Foreign Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_PLATNOSCI ADD CONSTRAINT WWW_PLATNOSCI_ID_FK FOREIGN KEY (ID) REFERENCES GM_SPOSOBY_ZAP (ID) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE WWW_PLATNOSCI ADD CONSTRAINT WWW_PLATNOSCI_ZNACZNIK_ID_FK FOREIGN KEY (ZNACZNIK_ID) REFERENCES R3_ZNACZNIKI (ID) ON DELETE SET NULL ON UPDATE CASCADE;


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX WWW_PLATNOSCI_DATY_IND ON WWW_PLATNOSCI (CDATE, MDATE);
CREATE INDEX WWW_PLATNOSCI_INSTALACJA_IND ON WWW_PLATNOSCI (INSTALACJA);


/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT SELECT, INSERT, UPDATE, DELETE ON WWW_PLATNOSCI TO WWW_ROLE;
